<?php

/*
	swf_rect.inc
	2010/09/09 - (c)N,KENC
	version 1.0.0
*/

require_once("./com/kenc/util/Util.inc");

class swf_rect{
	var $size=0;
	var $min_x=0;
	var $max_x=0;
	var $min_y=0;
	var $max_y=0;
	
	function setData( $sx, $sy, $lx, $ly )
	{
		$this->min_x = $sx;
		$this->max_x = $lx;
		$this->min_y = $sy;
		$this->max_y = $ly;
	}
	
	function loadData( $data, $pos, $f )
	{
		$bpos=$pos<<3;
		
		$this->size		= Util::getBit( $data, $bpos, 5, $f );
		$bpos+=5;
		$this->min_x	= Util::getBit( $data, $bpos, $this->size, $f );
		$bpos+=$this->size;
		$this->max_x	= Util::getBit( $data, $bpos, $this->size, $f );
		$bpos+=$this->size;
		$this->min_y	= Util::getBit( $data, $bpos, $this->size, $f );
		$bpos+=$this->size;
		$this->max_y	= Util::getBit( $data, $bpos, $this->size, $f );
		$bpos+=$this->size;
		
		if( ($bpos&0x07)!=0 )return ($bpos>>3)+1;
		else				 return ($bpos>>3);
	}
	
	function getBuff()
	{
		$x = $this->min_x;
		$y = $this->min_y;
		$w = $this->max_x;
		$h = $this->max_y;
		
		$blen	= 0;
		$max	= 0;
		$size	= 0;
		$bpos	= 0;
		
		$ret="";
		$tmp=0;
		
		$blen = Util::useBitLen( $x );
		if( $max<$blen )$max=$blen;
		$blen = Util::useBitLen( $y );
		if( $max<$blen )$max=$blen;
		$blen = Util::useBitLen( $w );
		if( $max<$blen )$max=$blen;
		$blen = Util::useBitLen( $h );
		if( $max<$blen )$max=$blen;
		
		$tmp=($max&0x1f)<<3;
		$bpos=5;
		
		for( $i=0; $i<$max; $i++, $bpos++ ){
			$p=$bpos%8;
			if( $p==0 ){
				$ret.=chr($tmp);
				$tmp=0;
			}
			$tmp|=( ($x>>($max-1-$i) )&0x01 )<<(7-$p);
		}
		for( $i=0; $i<$max; $i++, $bpos++ ){
			$p=$bpos%8;
			if( $p==0 ){
				$ret.=chr($tmp);
				$tmp=0;
			}
			$tmp|=( ($w>>($max-1-$i) )&0x01 )<<(7-$p);
		}
		for( $i=0; $i<$max; $i++, $bpos++ ){
			$p=$bpos%8;
			if( $p==0 ){
				$ret.=chr($tmp);
				$tmp=0;
			}
			$tmp|=( ($y>>($max-1-$i) )&0x01 )<<(7-$p);
		}
		for( $i=0; $i<$max; $i++, $bpos++ ){
			$p=$bpos%8;
			if( $p==0 ){
				$ret.=chr($tmp);
				$tmp=0;
			}
			$tmp|=( ($h>>($max-1-$i) )&0x01 )<<(7-$p);
		}
		
		if($bpos%8!=0)$ret.=chr($tmp);
		
		return $ret;
	}
}

?>