<?php

/*
	Util.inc
	2010/09/09 - (c)N,KENC
	version 1.0.0
*/
class Util{

	function getBit( $data, $bpos, $blen, $f )
	{
		$ret=0;
		$p=($bpos)>>3;
		$b=($bpos)&0x07;
		$d=($blen)>>3;

		for( $i=0; $i<$blen; $i++ ){
			$tmp = ord( substr($data,$p,1) );
			$ret |= (($tmp>>(7-$b))&0x1)<<(($blen-1)-$i);
			$bpos+=1;
			$p=($bpos)>>3;
			$b=($bpos)&0x07;
		}
		if( ($ret>>($blen-1)) && $f ){
			for( $i=$blen; $i<32; $i++ ){
				$ret |= 1<<($i);
			}
		}
		
		return $ret;
	}
	
	function useBitLen( $v )
	{
		$val = intval($v);
		$ret=0;
		for( $i=0; $i<32; $i++ ){
			if( (($val>>$i)&0x01)!=0 ){
				$ret=$i+1;
			}
		}
		
		if( $v>=0 )$ret+=1;
		
		return $ret;
	}
	
	function getInt( $data, $pos )
	{
		$s0=substr( $data, $pos, 1 );
		$s1=substr( $data, $pos+1, 1 );
		$s2=substr( $data, $pos+2, 1 );
		$s3=substr( $data, $pos+3, 1 );
		
		return ord($s0)|(ord($s1)<<8)|(ord($s2)<<16)|(ord($s3)<<24);
	}
	
	function getShort( $data, $pos )
	{
		$s0=substr( $data, $pos, 1 );
		$s1=substr( $data, $pos+1, 1 );
		
		return ord($s0)|(ord($s1)<<8);
	}
	
	function getByte( $data, $pos )
	{
		$s0=substr( $data, $pos, 1 );
		
		return ord($s0);
	}
	
	function getIntBuff( $val )
	{
		$ret="";
		$ret.=chr( (($val)&0xff) );
		$ret.=chr( (($val>>8)&0xff) );
		$ret.=chr( (($val>>16)&0xff) );
		$ret.=chr( (($val>>24)&0xff) );
		return $ret;
	}
	
	function getShortBuff( $val )
	{
		$ret="";
		$ret.=chr( (($val)&0xff) );
		$ret.=chr( (($val>>8)&0xff) );
		return $ret;
	}
	
	function getByteBuff( $val )
	{
		$ret="";
		$ret.=chr( (($val)&0xff) );
		return $ret;
	}
	
	function getFile( $fname )
	{
		$data="";
		$fp=fopen( $fname, 'rb' );
		$data=fread( $fp, filesize($fname) );
		fclose($fp);
		return $data;
	}
	
	function setFile( $fname, $data )
	{
		$fp=fopen( $fname, 'wb' );
		fwrite( $fp, $data, strlen($data) );
		fclose($fp);
	}
}

?>